<?php
/* Autor...:  */
/* Esquema.: CP_MetodosPago.xml */
/* Generado: 2021-07-14 02:15:37 */

/* Metodos de acceso a los campos de la tabla CP_MetodosPago */
abstract class BaseCP_MetodosPagoBN
{
    /* Campos de la tabla */
    private $i_MetodoPagoId;    // MetodoPagoId: ( no definido )
    private $s_Nombre;    // Nombre: ( no definido )
    private $s_Descripcion;    // Descripcion: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )

    /* Establece el valor del campo MetodoPagoId */
    public function setMetodoPagoId( $i_MetodoPagoId )
    {
        $this->i_MetodoPagoId = $i_MetodoPagoId;
    }

    /* Obtiene el valor del campo MetodoPagoId */
    public function getMetodoPagoId()
    {
        return $this->i_MetodoPagoId;
    }

    /* Establece el valor del campo Nombre */
    public function setNombre( $s_Nombre )
    {
        $this->s_Nombre = $s_Nombre;
    }

    /* Obtiene el valor del campo Nombre */
    public function getNombre()
    {
        return $this->s_Nombre;
    }

    /* Establece el valor del campo Descripcion */
    public function setDescripcion( $s_Descripcion )
    {
        $this->s_Descripcion = $s_Descripcion;
    }

    /* Obtiene el valor del campo Descripcion */
    public function getDescripcion()
    {
        return $this->s_Descripcion;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'MetodoPagoId' => $this->getMetodoPagoId(),
            'Nombre' => $this->getNombre(),
            'Descripcion' => $this->getDescripcion(),
            'Estado' => $this->getEstado(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto CP_MetodosPagoBN desde un RecordSet */
    public static function retrieveByRs( $o_CP_MetodosPagoRs )
    {
        $o_CP_MetodosPagoBN = new CP_MetodosPagoBN();
        $o_CP_MetodosPagoBN->setMetodoPagoId( ( integer ) $o_CP_MetodosPagoRs[ "MetodoPagoId" ] );
        $o_CP_MetodosPagoBN->setNombre( $o_CP_MetodosPagoRs[ "Nombre" ] );
        $o_CP_MetodosPagoBN->setDescripcion( $o_CP_MetodosPagoRs[ "Descripcion" ] );
        $o_CP_MetodosPagoBN->setEstado( $o_CP_MetodosPagoRs[ "Estado" ] );
        $o_CP_MetodosPagoBN->setUsuarioCreacion( $o_CP_MetodosPagoRs[ "UsuarioCreacion" ] );
        $o_CP_MetodosPagoBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_CP_MetodosPagoRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_CP_MetodosPagoBN->setUsuarioModificacion( $o_CP_MetodosPagoRs[ "UsuarioModificacion" ] );
        $o_CP_MetodosPagoBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_CP_MetodosPagoRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        return $o_CP_MetodosPagoBN;
    }
}
?>